# Class CGOMesh

java.lang.Object
org.jmol.util.MeshSurface
org.jmol.shape.Mesh
org.jmol.shapespecial.DrawMesh
org.jmol.shapecgo.CGOMesh

public class CGOMesh extends DrawMesh

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`ALPHA`
`static final int`
`ALPHA_TRIANGLE`
`static final int`
`BEGIN`
`static final int`
`BOUNDING_BOX`
`static final int`
`CGO_ACCESSIBILITY_ARRAY`
`static final int`
`CGO_COLOR_ARRAY`
`static final int`
`CGO_NORMAL_ARRAY`
`static final int`
`CGO_PICK_COLOR_ARRAY`
`static final int`
`CGO_TEX_COORD_ARRAY`
`static final int`
`CGO_VERTEX_ARRAY`
`static final int`
`CHAR`
`Lst<Short>`
`cList`
`Lst<Object>`
`cmds`
`static final int`
`COLOR`
`static final int`
`CONE`
`static final int`
`CUSTOM_CYLINDER`
`static final int`
`CYLINDER`
`static final int`
`DISABLE`
`static final int`
`DOTWIDTH`
`static final int`
`DRAW_ARRAYS`
`static final int`
`DRAW_BUFFERS`
`static final int`
`DRAW_BUFFERS_INDEXED`
`static final int`
`DRAW_BUFFERS_NOT_INDEXED`
`static final int`
`ELLIPSOID`
`static final int`
`ENABLE`
`static final int`
`END`
`static final int`
`FONT`
`static final int`
`FONT_AXES`
`static final int`
`FONT_SCALE`
`static final int`
`FONT_VERTEX`
`static final int`
`GL_LINE_LOOP`
`static final int`
`GL_LINE_STRIP`
`static final int`
`GL_LINES`
`static final int`
`GL_POINTS`
`static final int`
`GL_TRIANGLE_FAN`
`static final int`
`GL_TRIANGLE_STRIP`
`static final int`
`GL_TRIANGLES`
`static final int`
`INDENT`
`static final int`
`JMOL_DIAMETER`
`static final int`
`JMOL_PS`
`static final int`
`JMOL_SCREEN`
`static final int`
`JMOL_UVMAP`
`static final int`
`LINEWIDTH`
`float`
`meshWidth`
`Lst<Short>`
`nList`
`static final int`
`NORMAL`
`static final int`
`PICK_COLOR`
`static final int`
`PS_CLOSEPATH`
`static final int`
`PS_LINETO`
`static final int`
`PS_MOVETO`
`static final int`
`PS_NEWPATH`
`static final int`
`PS_SCALE`
`static final int`
`PS_SETLINEWIDTH`
`static final int`
`PS_SHOWPAGE`
`static final int`
`PS_STROKE`
`static final int`
`QUADRIC`
`static final int`
`RESET_NORMAL`
`static final int`
`SAUSAGE`
`static final int`
`SIMPLE_LINE`
`static final int`
`SPECIAL`
`static final int`
`SPHERE`
`static final int`
`STOP`
`static final int`
`TRICOLOR_TRIANGLE`
`static final int`
`VERTEX`
`static final int`
`WIDTHSCALE`

### Fields inherited from class DrawMesh

`bsMeshesVisible, drawArrowScale, drawType, fontID, isBarb, isScaleSet, isVector, modelFlags, noHead, scale, thisModelOnly, titleColor`

### Fields inherited from class Mesh

`atomIndex, bsTemp, cappingObject, checkByteCount, color, colorCommand, colorDensity, colorType, connectedAtoms, diameter, drawTriangles, fillTriangles, frontOnly, hasTranslucentVertices, havePlanarContours, haveXyPoints, hoverLabel, index, insideOut, isModelConnected, isShell, isTwoSided, isValid, lattice, lighting, lineData, linkedMesh, meshColix, modelIndex, normixes, PREVIOUS_MESH_ID, ptCenter, recalcAltVertices, reverseColor, scale3d, scriptCommand, showContourLines, showPoints, showTriangles, slabbingObject, symopColixes, symopNormixes, symops, thisID, title, unitCell, useColix, vAB, visibilityFlags, visible, volumeRenderPointSize, vTemp, width`

### Fields inherited from class MeshSurface

`altVertices, bsDisplay, bsPolygons, bsSlabDisplay, bsSlabGhost, colix, colixBack, colorsExplicit, dataOnly, haveQuads, iA, iB, iC, isColorSolid, isDrawPolygon, isMerged, mat4, mergePolygonCount0, mergeVertexCount0, meshType, normalCount, normals, normalsTemp, normixCount, nSets, oabc, offset, P_CHECK, P_CONTOUR, P_EXPLICIT_COLOR, pc, pcs, pis, polygonCount0, SEED_COUNT, slabColix, slabMeshType, slabOptions, surfaceAtoms, surfaceSet, vc, vcs, vertexCount0, vertexSets, vertexSource, vs, vvs, vwr`

## Method Summary

Modifier and Type
Method
Description
`void`
`addColix(int i)`
`void`
`addNormix(int i)`
`void`
`clear(String meshType)`
`void`
`clearColixList()`
`void`
`clearNormixList()`
`int`
`getDrawArrayParams(int pt0, int[] info)`
`float`
`getFloat(int i)`
`int`
`getInt(int i)`
`static Map<String,Integer>`
`getKeyMap()`
`void`
`getPoint(int i, T3 pt)`
`static int`
`getSize(int i, boolean is2D)`

### Methods inherited from class DrawMesh

`deleteAtoms, isRenderScalable`

### Methods inherited from class Mesh

`checkWithin, clearMesh, getBoundingBox, getInfo, getMinDistance2ForVertexGrouping, getNormals, getNormalsTemp, getOffsetVertices, getRendering, getState, getUnitCell, getVertexIndexFromNumber, getVisibleVBS, getVisibleVertexBitSet, initialize, mesh1, rotateTranslate, setLighting, setNormixes, setShowWithin, setTokenProperty, setTranslucent, setVisibilityFlags, sumVertexNormals, sumVertexNormals2`

### Methods inherited from class MeshSurface

`addPolygon, addPolygonC, addQuad, addTriangle, addTriangleCheck, addV, addVCVal, getFaces, getMeshSlicer, getResolution, getSlabColor, getSlabType, getSphereData, getSphericalInterpolationFraction, getVertices, invalidatePolygons, newMesh, resetSlab, setABC, setBoundingBox, setBox, setColix, setColixBack, setPolygonCount, setTranslucentVertices, slabBrillouin, slabPolygonsList`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### cmds

public Lst<Object> cmds

### GL_POINTS

public static final int GL_POINTS

See Also:
  - Constant Field Values

### GL_LINES

public static final int GL_LINES

See Also:
  - Constant Field Values

### GL_LINE_LOOP

public static final int GL_LINE_LOOP

See Also:
  - Constant Field Values

### GL_LINE_STRIP

public static final int GL_LINE_STRIP

See Also:
  - Constant Field Values

### GL_TRIANGLES

public static final int GL_TRIANGLES

See Also:
  - Constant Field Values

### GL_TRIANGLE_STRIP

public static final int GL_TRIANGLE_STRIP

See Also:
  - Constant Field Values

### GL_TRIANGLE_FAN

public static final int GL_TRIANGLE_FAN

See Also:
  - Constant Field Values

### STOP

public static final int STOP

See Also:
  - Constant Field Values

### SIMPLE_LINE

public static final int SIMPLE_LINE

See Also:
  - Constant Field Values

### BEGIN

public static final int BEGIN

See Also:
  - Constant Field Values

### END

public static final int END

See Also:
  - Constant Field Values

### VERTEX

public static final int VERTEX

See Also:
  - Constant Field Values

### NORMAL

public static final int NORMAL

See Also:
  - Constant Field Values

### COLOR

public static final int COLOR

See Also:
  - Constant Field Values

### SPHERE

public static final int SPHERE

See Also:
  - Constant Field Values

### TRICOLOR_TRIANGLE

public static final int TRICOLOR_TRIANGLE

See Also:
  - Constant Field Values

### CYLINDER

public static final int CYLINDER

See Also:
  - Constant Field Values

### LINEWIDTH

public static final int LINEWIDTH

See Also:
  - Constant Field Values

### WIDTHSCALE

public static final int WIDTHSCALE

See Also:
  - Constant Field Values

### ENABLE

public static final int ENABLE

See Also:
  - Constant Field Values

### DISABLE

public static final int DISABLE

See Also:
  - Constant Field Values

### SAUSAGE

public static final int SAUSAGE

See Also:
  - Constant Field Values

### CUSTOM_CYLINDER

public static final int CUSTOM_CYLINDER

See Also:
  - Constant Field Values

### DOTWIDTH

public static final int DOTWIDTH

See Also:
  - Constant Field Values

### ALPHA_TRIANGLE

public static final int ALPHA_TRIANGLE

See Also:
  - Constant Field Values

### ELLIPSOID

public static final int ELLIPSOID

See Also:
  - Constant Field Values

### FONT

public static final int FONT

See Also:
  - Constant Field Values

### FONT_SCALE

public static final int FONT_SCALE

See Also:
  - Constant Field Values

### FONT_VERTEX

public static final int FONT_VERTEX

See Also:
  - Constant Field Values

### FONT_AXES

public static final int FONT_AXES

See Also:
  - Constant Field Values

### CHAR

public static final int CHAR

See Also:
  - Constant Field Values

### INDENT

public static final int INDENT

See Also:
  - Constant Field Values

### ALPHA

public static final int ALPHA

See Also:
  - Constant Field Values

### QUADRIC

public static final int QUADRIC

See Also:
  - Constant Field Values

### CONE

public static final int CONE

See Also:
  - Constant Field Values

### DRAW_ARRAYS

public static final int DRAW_ARRAYS

See Also:
  - Constant Field Values

### RESET_NORMAL

public static final int RESET_NORMAL

See Also:
  - Constant Field Values

### PICK_COLOR

public static final int PICK_COLOR

See Also:
  - Constant Field Values

### DRAW_BUFFERS

public static final int DRAW_BUFFERS

See Also:
  - Constant Field Values

### DRAW_BUFFERS_INDEXED

public static final int DRAW_BUFFERS_INDEXED

See Also:
  - Constant Field Values

### BOUNDING_BOX

public static final int BOUNDING_BOX

See Also:
  - Constant Field Values

### DRAW_BUFFERS_NOT_INDEXED

public static final int DRAW_BUFFERS_NOT_INDEXED

See Also:
  - Constant Field Values

### SPECIAL

public static final int SPECIAL

See Also:
  - Constant Field Values

### CGO_VERTEX_ARRAY

public static final int CGO_VERTEX_ARRAY

See Also:
  - Constant Field Values

### CGO_NORMAL_ARRAY

public static final int CGO_NORMAL_ARRAY

See Also:
  - Constant Field Values

### CGO_COLOR_ARRAY

public static final int CGO_COLOR_ARRAY

See Also:
  - Constant Field Values

### CGO_PICK_COLOR_ARRAY

public static final int CGO_PICK_COLOR_ARRAY

See Also:
  - Constant Field Values

### CGO_ACCESSIBILITY_ARRAY

public static final int CGO_ACCESSIBILITY_ARRAY

See Also:
  - Constant Field Values

### CGO_TEX_COORD_ARRAY

public static final int CGO_TEX_COORD_ARRAY

See Also:
  - Constant Field Values

### JMOL_DIAMETER

public static final int JMOL_DIAMETER

See Also:
  - Constant Field Values

### JMOL_SCREEN

public static final int JMOL_SCREEN

See Also:
  - Constant Field Values

### JMOL_UVMAP

public static final int JMOL_UVMAP

See Also:
  - Constant Field Values

### JMOL_PS

public static final int JMOL_PS

See Also:
  - Constant Field Values

### PS_NEWPATH

public static final int PS_NEWPATH

See Also:
  - Constant Field Values

### PS_CLOSEPATH

public static final int PS_CLOSEPATH

See Also:
  - Constant Field Values

### PS_STROKE

public static final int PS_STROKE

See Also:
  - Constant Field Values

### PS_SETLINEWIDTH

public static final int PS_SETLINEWIDTH

See Also:
  - Constant Field Values

### PS_SCALE

public static final int PS_SCALE

See Also:
  - Constant Field Values

### PS_MOVETO

public static final int PS_MOVETO

See Also:
  - Constant Field Values

### PS_LINETO

public static final int PS_LINETO

See Also:
  - Constant Field Values

### PS_SHOWPAGE

public static final int PS_SHOWPAGE

See Also:
  - Constant Field Values

### nList

public Lst<Short> nList

### cList

public Lst<Short> cList

### meshWidth

public float meshWidth

## Method Details

### getSize

public static int getSize(int i, boolean is2D)

### getKeyMap

public static Map<String,Integer> getKeyMap()

### clear

public void clear(String meshType)

Overrides:
  `clear` in class `DrawMesh`

### getDrawArrayParams

public int getDrawArrayParams(int pt0, int[] info)

Parameters:
  `pt0` -
  `info` -
Returns:
  [

### addColix

public void addColix(int i)

### addNormix

public void addNormix(int i)

### clearNormixList

public void clearNormixList()

### clearColixList

public void clearColixList()

### getPoint

public void getPoint(int i, T3 pt)

Parameters:
  `i` - pointer to PRECEDING item
  `pt` -

### getInt

public int getInt(int i)

Parameters:
  `i` - pointer to THIS value
Returns:
  int

### getFloat

public float getFloat(int i)

Parameters:
  `i` - pointer to THIS value
Returns:
  float